package com.training.jaxws.sun.topdown.client.test;

import org.jboss.aop.joinpoint.Invocation;
import org.jboss.aop.joinpoint.MethodInvocation;
import org.jboss.aop.advice.Interceptor;

public class MethodInterceptor implements Interceptor
{
	public MethodInterceptor() {
		System.out.println("<<<<<<  Constructor >>>>>>");
	}
	
   public String getName() { return "MethodInterceptor"; }

   public Object invoke(Invocation invocation) throws Throwable
   {
	   System.out.println("<<< Entering MethodInterceptor 1");
      try
      {
         MethodInvocation mi = (MethodInvocation)invocation;
         System.out.println("<<< Entering MethodInterceptor for: " + mi.getMethod().toString());
         return invocation.invokeNext();
      }
      finally
      {
         System.out.println(">>> Leaving MethodInterceptor");
      }
   }
}